<?php
/*
Plugin Name: TxtBear
Plugin URI: http://www.txtbear.com/
Description: Embed documents into your posts.
Author: eload24 ag
Author URI: http://www.eload24.com/
Version: 1.1.10
*/

// load plugin configuration
include(dirname(__FILE__).'/config.php');

$strPluginsFolder = WP_PLUGIN_URL;
if(is_ssl()) {
	$strPluginsFolder = preg_replace('/^http:\/\//', 'https://', $strPluginsFolder);
}

// load localizations
load_plugin_textdomain('txtbear', WP_PLUGIN_URL.'/txtbear/languages/', 'txtbear/languages/');
load_plugin_textdomain('txtbear', '/');

// http://codex.wordpress.org/Embed
if(function_exists('wp_oembed_add_provider')) {
	wp_oembed_add_provider('http://view.txtbear.com/*', 'http://api.txtbear.com/book/oembed.{format}');
}

define('TXTBEAR_URL', $strPluginsFolder.'/txtbear/');

function txtbear_activate() {
	global $wpdb;
	if(!$wpdb->query("SHOW TABLES LIKE '{$wpdb->prefix}txtbear_thumb_cache'")) {
		$wpdb->query("CREATE TABLE `{$wpdb->prefix}txtbear_thumb_cache` (
			`id` INT( 1 ) NOT NULL AUTO_INCREMENT PRIMARY KEY ,
			`url` VARCHAR( 50 ) NOT NULL ,
			`thumb` VARCHAR( 60 ) NOT NULL ,
			`width` INT( 1 ) NOT NULL ,
			`height` INT( 1 ) NOT NULL ,
			`time` INT( 1 ) NOT NULL ,
			UNIQUE ( `url` )
			) ENGINE = MYISAM");
	}
	// find out if user is in a German country
	$strCountry = '';
	$arrReply = get('http://ipinfodb.com/ip_query.php?ip='.$_SERVER['REMOTE_ADDR']);
	if($arrReply['status'] == 200) {
		$objReply = new SimpleXMLElement($arrReply['data']);
		$strCountry = htmlentities(utf8_decode($objReply->CountryName));
	}
	add_option('txtbear_admin_country', $strCountry);
}

function txtbear_deactivate() {
	global $wpdb;
	$wpdb->query("DROP TABLE `{$wpdb->prefix}txtbear_thumb_cache`");
	delete_option('txtbear_admin_country');
}

// display media toolbar buttons
function txtbear_button() {
	global $post_ID, $temp_ID;
	$strFrameUrl = TXTBEAR_URL.'%s.php?post_id='.(0 == $post_ID ? $temp_ID : $post_ID).'&amp;TB_iframe=true';
	if(is_ssl()) {
		$strFrameUrl = preg_replace('/^http:\/\//', 'https://', $strFrameUrl);
	}
	echo '<a href="'.sprintf($strFrameUrl, 'doc-upload').'" class="thickbox" title="'.__('Embed document', 'txtbear').'"><img src="'.TXTBEAR_URL.'images/txtbear-button.png" alt="'.__('Embed document', 'txtbear').'" width="15" height="12" /></a>';
	if(txtbear_admin_is_german()) {
		echo '<a href="'.sprintf($strFrameUrl, 'search-eload24').'" class="thickbox" title="'.__('Embed eload24 ebook', 'txtbear').'"><img src="'.TXTBEAR_URL.'images/eload24-button.png" alt="'.__('Embed eload24 ebook', 'txtbear').'" width="17" height="12" /></a>';
	}
}

function txtbear_thumb($strUrl) {
	global $wpdb;
	$strUrlDb = mysql_real_escape_string($strUrl);
	$objThumb = $wpdb->get_row("
		SELECT thumb, width, height, time
		FROM {$wpdb->prefix}txtbear_thumb_cache
		WHERE url = '$strUrlDb'");
	if(!$objThumb || $objThumb->time < time() - 86400) {
		$arrData = get("http://api.txtbear.com/book/oembed.sphp?url=$strUrl");
		if($arrData['status'] == 200) {
			$arrData = unserialize($arrData['data']);
			if(!isset($arrData['fail'])) {
				$strEmbed = $arrData['html'];
				$arrMatch = array();
				preg_match('/<img class="cover" src="(.+)" alt=".+" width="(\d+)" height="(\d+)"/', $strEmbed, $arrMatch);
				$strThumb = $arrMatch[1];
				$intWidth = $arrMatch[2];
				$intHeight = $arrMatch[3];
				if($intWidth < $intHeight) { // portrait
					if($intHeight > 200) {
						$intWidth = intval($intWidth * 200 / $intHeight);
						$intHeight = 200;
					}
				}
				else { // landscape
					if($intWidth > 200) {
						$intHeight = intval($intHeight * 200 / $intWidth);
						$intWidth = 200;
					}
				}
				$wpdb->query("
					REPLACE INTO {$wpdb->prefix}txtbear_thumb_cache SET
					id = NULL,
					url = '$strUrlDb',
					thumb = '$strThumb',
					width = $intWidth,
					height = $intHeight,
					time = UNIX_TIMESTAMP()");
				$objThumb = new stdClass;
				$objThumb->thumb = $strThumb;
				$objThumb->width = $intWidth;
				$objThumb->height = $intHeight;
				$objThumb->time = time();
				return $objThumb;
			}
			return false;
		}
		return false;
	}
	return $objThumb;
}

function txtbear_insertembed($strText) {
	// auto embed
	$arrMatch = array();
	preg_match_all('/\[doc( [^\]]+)\]/', $strText, $arrMatch);
	for($i = 0; $i < count($arrMatch[0]); $i++) {
		$strParams = $arrMatch[1][$i];
		// txtbear id
		$strTxtbear = false;
		$arrMatch2 = array();
		if(preg_match('/ txtbear=(\w+)/', $strParams, $arrMatch2)) {
			$strTxtbear = $arrMatch2[1];
		}
		// display mode
		$strDisplayMode = 'preview';
		$arrMatch2 = array();
		if(preg_match('/ mode=(preview|link)/', $strParams, $arrMatch2)) {
			$strDisplayMode = $arrMatch2[1];
		}
		// ebook title
		$strTitle = '';
		$arrMatch2 = array();
		if(preg_match('/ title="(.+)"/', $strParams, $arrMatch2)) {
			$strTitle = $arrMatch2[1];
			$strTitle = str_replace('"', '&quot;', $strTitle);
		}
		// align
		$strAlign = '';
		$arrMatch2 = array();
		if(preg_match('/ align=(left|center|right)/', $strParams, $arrMatch2)) {
			$strAlign = $arrMatch2[1];
		}
		// ebook id
		$intEbook = 0;
		$arrMatch2 = array();
		if(preg_match('/ eload24=(\d+)/', $strParams, $arrMatch2)) {
			$intEbook = $arrMatch2[1];
		}
		// extension
		$strExtend = '';
		$arrMatch2 = array();
		if(preg_match('/ extend="(.+)"/', $strParams, $arrMatch2)) {
			$strExtend = $arrMatch2[1];
		}
		// if eload24
		if($intEbook && $strTxtbear) {
			// build URL
			$strUrl = 'http://view.txtbear.com/'.$strTxtbear.'/?pid='.$intEbook.'#plugins=http://res.txtbear.com.s3.amazonaws.com/plugins/eload24.js' . ($strExtend ? '&'.$strExtend : '');
			// build embed
			$strEbook = sprintf('%05d', $intEbook);
			switch($strDisplayMode) {
				case 'preview':
					$strEmbed = '<a href="'.$strUrl.'"><img class="cover" src="http://d1ekua9ie1ovig.cloudfront.net/cover/'.$strEbook.'.jpg" width="200" height="147" alt="'.$strTitle.'" /></a>';
					switch($strAlign) {
						case 'left':
							$strEmbed = '<div style="float: left; margin: 0 2em 1em 0"><div class="TxtBearEmbed">'.$strEmbed.'</div></div>';
							break;
						case 'right':
							$strEmbed = '<div style="float: right; margin: 0 0 1em 2em"><div class="TxtBearEmbed">'.$strEmbed.'</div></div>';
							break;
						case 'center':
							$strEmbed = '<div style="position: relative; left: 50%; margin: 1em 0 1em -100px"><div class="TxtBearEmbed">'.$strEmbed.'</div></div>';
							break;
						default:
							$strEmbed = '<div class="TxtBearEmbed">'.$strEmbed.'</div>';
							break;
					}
					break;
				case 'link':
					if(!$strTitle) {
						$strTitle = __('View ebook for free', 'txtbear');
					}
					$strEmbed = '<a class="TxtBearEmbedInline" href="'.$strUrl.'" title="'.__('View ebook for free', 'txtbear').'">'.$strTitle.'</a>';
					if($strAlign) {
						$strEmbed = '<span style="display: block; text-align: '.$strAlign.'; margin: 1em 0">'.$strEmbed.'</span>';
					}
					break;
			}
			$strEmbed .= '<script type="text/javascript">if (!window.TxtBearEmbed) { document.write(unescape("%3Cscript src=\'http://static.txtbear.com/v/embed.js\' type=\'text/javascript\'%3E%3C/script%3E")); window.TxtBearEmbed = true; }</script>';
		}
		// if valid doc
		if($strTxtbear) {
			// build URL
			$strUrl = 'http://view.txtbear.com/'.$strTxtbear.'/' . ($strExtend ? '#'.$strExtend : '');
			// build embed
			$objThumb = txtbear_thumb($strUrl);
			switch($strDisplayMode) {
				case 'preview':
					$strEmbed = '<a href="'.$strUrl.'"><img class="cover" src="'.$objThumb->thumb.'" width="'.$objThumb->width.'" height="'.$objThumb->height.'" alt="'.$strTitle.'" /></a>';
					switch($strAlign) {
						case 'left':
							$strEmbed = '<span style="display: block; float: left; width: '.$objThumb->width.'px; height: '.$objThumb->height.'px; margin: 0 2em 1em 0"><span class="TxtBearEmbed">'.$strEmbed.'</span></span>';
							break;
						case 'right':
							$strEmbed = '<span style="display: block; float: right; width: '.$objThumb->width.'px; height: '.$objThumb->height.'px; margin: 0 0 1em 2em"><span class="TxtBearEmbed">'.$strEmbed.'</span></span>';
							break;
						case 'center':
							$strEmbed = '<span style="display: block; position: relative; left: 50%; margin: 1em 0 1em -100px; height: '.$objThumb->height.'px"><span class="TxtBearEmbed">'.$strEmbed.'</span></span>';
							break;
						default:
							$strEmbed = '<span style="display: block; height: '.$objThumb->height.'px" class="TxtBearEmbed">'.$strEmbed.'</span>';
							break;
					}
					break;
				case 'link':
					if(!$strTitle) {
						$strTitle = __('View document for free', 'txtbear');
					}
					$strEmbed = '<a class="TxtBearEmbedInline" href="'.$strUrl.'" title="'.__('View document for free', 'txtbear').'">'.$strTitle.'</a>';
					if($strAlign) {
						$strEmbed = '<span style="display: block; text-align: '.$strAlign.'; margin: 1em 0">'.$strEmbed.'</span>';
					}
					break;
			}
			$strEmbed .= '<script type="text/javascript">if (!window.TxtBearEmbed) { document.write(unescape("%3Cscript src=\'http://static.txtbear.com/v/embed.js\' type=\'text/javascript\'%3E%3C/script%3E")); window.TxtBearEmbed = true; }</script>';
		}
		else {
			$strEmbed = ' ('.__('Invalid embed code parameters.', 'txtbear').') ';
		}
		// insert
		$strText = str_replace($arrMatch[0][$i], $strEmbed, $strText);
	}
	return $strText;
}

register_activation_hook(__FILE__, 'txtbear_activate');
register_deactivation_hook(__FILE__, 'txtbear_deactivate');
add_action('media_buttons', 'txtbear_button', 20);
add_action('the_content', 'txtbear_insertembed');

?>